package jadean.dean.java.resourceparser.javaparser;

import jadean.dean.java.JavaResource;
import jadean.dean.java.resourceparser.JavaResourceFilter;

public class JavaSourceResourceFilter implements JavaResourceFilter {
	
	public boolean accept(JavaResource resource) {
		if (resource.getName().startsWith("java.lang.")) {
			return false;
		}
		boolean classInJavaLang = true;
		try {
			Class.forName("java.lang." + resource.getName());
		}
		catch (ClassNotFoundException cnfe) {
			classInJavaLang = false;
		}
		if (classInJavaLang) {
			return false;
		}
		return true;
	}

}
