package jadean.dean.java.resources;

import java.util.HashSet;

public class JavaResourceContext {
	private String classPackage;
	private HashSet<String> classImportedPackages;
	private HashSet<String> classImportedClasses;

	public JavaResourceContext() {
		this.setClassPackage("");
		this.setClassImportedPackages(new HashSet<String>());
		this.setClassImportedClasses(new HashSet<String>());
	}
	
	public JavaResourceContext(String classPackage, HashSet<String> classImportedPackages, HashSet<String> classImportedClasses) {
		this.setClassPackage(classPackage);
		this.setClassImportedPackages(classImportedPackages);
		this.setClassImportedClasses(classImportedClasses);
	}

	public void setClassPackage(String classPackage) {
		this.classPackage = classPackage;
	}

	public String getClassPackage() {
		return classPackage;
	}	
	
	public void addImportedPackage(String pkg) {
		this.classImportedPackages.add(pkg);
	}
	
	public void setClassImportedPackages(HashSet<String> classImports) {
		this.classImportedPackages = classImports;
	}

	public HashSet<String> getClassImportedPackages() {
		return this.classImportedPackages;
	}
	
	public void addImportedClass(String className) {
		this.classImportedClasses.add(className);
	}
	
	public void setClassImportedClasses(HashSet<String> classImportedClasses) {
		this.classImportedClasses = classImportedClasses;
	}

	public HashSet<String> getClassImportedClasses() {
		return classImportedClasses;
	}

	public boolean equals(Object o) {
		if (o instanceof JavaResourceContext) {
			JavaResourceContext cnc = (JavaResourceContext) o;
			return
				cnc.getClassPackage().equals(this.getClassPackage()) &&
				cnc.getClassImportedPackages().containsAll(this.classImportedPackages) &&
				this.classImportedPackages.containsAll(cnc.getClassImportedPackages()) &&
				cnc.getClassImportedClasses().containsAll(this.classImportedClasses) &&
				this.classImportedClasses.containsAll(cnc.getClassImportedClasses());
		}
		return false;
	}
	
	public String toString() {
		return "ResourceContext[" + this.classPackage + ";" + this.classImportedClasses + ";" + this.classImportedPackages + "]";
	}
}
