package jadean.ui.handlers;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.handlers.HandlerUtil;

public class BaseDependencyAnalyzerHandler extends AbstractHandler {

	public Object execute(ExecutionEvent event) throws ExecutionException {
		DependencyAnalyzerHandlersFactory handlersFactory = DependencyAnalyzerHandlersFactory.getInstance();

		IStructuredSelection selection = (IStructuredSelection) HandlerUtil.getActiveMenuSelection(event);
		Object firstElement = selection.getFirstElement();

		String[] natureIDs = HandlerUtilities.getNatureIds(firstElement);
		if (natureIDs == null) {
			return null;
		}
		String[] supportedNatureIDs = HandlerUtilities.getSupportedNatureIds(natureIDs);
		if (supportedNatureIDs == null) {
			return null;
		}
		if (supportedNatureIDs.length == 1) {
			DependencyAnalyzerHandler handler = handlersFactory.getHandler(supportedNatureIDs[0]);
			handler.handle(firstElement);
		}
		else {
			return null;
		}
		return null;
	}

}
